function f90_psdnrm2(x,decomp_data, jx)  
  use typedesc
  real(kind(1.d0)), intent(in) ::  x(:,:)
  type(decomp_data_type), intent(in)  :: decomp_data
  integer, intent(in), optional :: jx
  real(kind(1.D0))              :: f90_psdnrm2
  integer  :: iix, ijx, lldx, in
  real(kind(1.D0)) :: nrm2_local

  interface 
     subroutine psdnrm2(n,alpha,x,ix,jx,ldx,&
	  & matrix_data,halo_index,ovrlap_index,ovrlap_elem) 
       integer, intent(in) :: matrix_data(*), halo_index(*),&
	    & ovrlap_index(*), ovrlap_elem(*)
       integer, intent(in) :: n,ix,jx,ldx
       real(kind(1.d0)), intent(in) :: x(ldx,*)
       real(kind(1.d0)), intent(out) ::  alpha
     end subroutine psdnrm2
  end interface
  
  iix = 1
  if (present(jx)) then
     ijx = jx
  else
     ijx = 1
  endif
  in = decomp_data%matrix_data(m_)
  lldx = size(x,1)
  if (f90_func_bug) then 
    lldx = decomp_data%matrix_data(n_col_)
  endif  
  
  call psdnrm2( in, nrm2_local, X, iix, ijx, lldx,&
       & decomp_data%matrix_data, decomp_data%halo_index,&
       & decomp_data%ovrlap_index,decomp_data%ovrlap_elem)
  
  f90_psdnrm2 = nrm2_local
  
  return
end function f90_psdnrm2

function f90_psdnrm2v(x,decomp_data)  
  use typedesc
  real(kind(1.d0)), intent(in) :: x(:)
  type(decomp_data_type), intent(in)  :: decomp_data
  real(kind(1.D0))              :: f90_psdnrm2v 
  integer  :: iix, ijx, lldx, in
  real(kind(1.D0)) :: nrm2_local

  interface 
     subroutine psdnrm2(n,alpha,x,ix,jx,ldx,&
	  & matrix_data,halo_index,ovrlap_index,ovrlap_elem) 
       integer, intent(in) :: matrix_data(*), halo_index(*),&
	    & ovrlap_index(*), ovrlap_elem(*)
       integer, intent(in) :: n,ix,jx,ldx
       real(kind(1.d0)), intent(in) :: x(ldx,*)
       real(kind(1.d0)), intent(out) ::  alpha
     end subroutine psdnrm2
  end interface
  
  iix = 1
  ijx = 1
  in = decomp_data%matrix_data(m_)
  lldx = size(x,1)
  if (f90_func_bug) then 
    lldx = decomp_data%matrix_data(n_col_)
  endif  
  
  call psdnrm2( in, nrm2_local, X, iix, ijx, lldx,&
       & decomp_data%matrix_data, decomp_data%halo_index,&
       & decomp_data%ovrlap_index,decomp_data%ovrlap_elem) 
  f90_psdnrm2v = nrm2_local
  return
end function f90_psdnrm2v

subroutine  f90_psdnrm2vs(res,x,decomp_data)  
  use typedesc
  real(kind(1.d0)), intent(in) :: x(:)
  type(decomp_data_type), intent(in)  :: decomp_data
  real(kind(1.D0)), intent(out) :: res
  integer  :: iix, ijx, lldx, in
  real(kind(1.D0)) :: nrm2_local

  interface 
     subroutine psdnrm2(n,alpha,x,ix,jx,ldx,&
	  & matrix_data,halo_index,ovrlap_index,ovrlap_elem) 
       integer, intent(in) :: matrix_data(*), halo_index(*),&
	    & ovrlap_index(*), ovrlap_elem(*)
       integer, intent(in) :: n,ix,jx,ldx
       real(kind(1.d0)), intent(in) :: x(ldx,*)
       real(kind(1.d0)), intent(out) ::  alpha
     end subroutine psdnrm2
  end interface
  
  iix = 1
  ijx = 1
  in = decomp_data%matrix_data(m_)
  lldx = size(x,1)
  
  call psdnrm2( in, nrm2_local, X, iix, ijx, lldx,&
       & decomp_data%matrix_data, decomp_data%halo_index,&
       & decomp_data%ovrlap_index,decomp_data%ovrlap_elem) 
  res = nrm2_local
  return
end subroutine f90_psdnrm2vs



